=begin
  Copyright 2014 Maxine Red <maxine@furfind.net>

  This file is part of toy-chooser.

  toy-chooser is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  toy-chooser is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with toy-chooser.  If not, see <http://www.gnu.org/licenses/>.
=end

class Chooser
  def fetch_bd
    net = Net::HTTP.new("bad-dragon.com",80)
    toys = JSON.parser.new(net.get("/products/getproducts").body).parse
    toys.reject!{|c|c["cat_id"].to_i!=1}
    toys = toys.sort{|t1,t2|t1["release_date"].to_i <=> t2["release_date"].to_i}
    toys.map!{|c|c["link_url"].sub(/.+bad-dragon.com/,"")}
    toys.each do |t|
      body = net.get(t).body
      html = Nokogiri::HTML.parse(body)
      id = html.css("span[itemprop=productID]").first.text
      name = html.css("span[itemprop=model]").first.text
      sizes = html.css("table.divided th").map{|th|th.text}
      sizes.shift # Just drop the first item.
      table = html.css("table.divided tr").map do |tr|
        tr.css("td").map{|td|td.text}
      end
      table.shift
      sql_query = "INSERT INTO toys";
      sizes.count.times do |i|
        size = sizes[i][0,1].sub("E","XL")
        size = "XS" if sizes[i] == "Mini"
        query = Hash.new
        query.store("sku",id)
        query.store("name",SQLite3::Database.quote(name))
        query.store("size",size)
        price = html.css("#size_inputs label").map do |x|
          if x.text.match(/^#{sizes[i]}/i) then
            x.css("i").text.sub("$","").to_i
          end
        end.compact.first
        price = html.css("span[itemprop=price]").first.text.to_i if !price
        query.store("price",price)
        table.each do |t|
          next if t[0].match(/thinnest|smallest/i)
          # We look only for biggest measures.
          col = t[0].downcase.sub(/meter of /,"_").sub(/umference of /,"_")
          col.gsub!(" ","_")
          col.gsub!(/_\(.+\)/,"")
          col = remove_aliases(col)
          inches = (t[i+1].to_f*100).round.to_i
          query.store(col,inches)
        end
        if i == 0 then
          sql_query += " (#{query.keys.join(",")}) VALUES\n"
        end
        sql_query += " ('#{query.values.join("','")}'),\n"
      end
      sql_query[-2,2] = ";"
      SQLite3::Database.new(@db_file) do |db|
        begin
          db.execute(sql_query)
        rescue
          p sql_query
          raise
        end
      end
      puts "Updated \"#{name}\" successfully."
    end
  end
  def remove_aliases(column)
    column = column.sub("usuable","usable").sub("avg._","")
    column = column.sub(/(thickest|largest)_part_of_/,"")
    column = column.sub(/_base/,"")
    # Other common aliases
    column = column.sub("tip","head").sub("middle","shaft").sub("bottom","knot")
    column = column.sub("shaft_ridges","knot").sub("medial_ring","knot")
    column = column.sub("bulb","knot")
    return column
  end
end
